import { TabService } from './../../services/tab.service';
import { debounceTime, filter } from 'rxjs/operators';
import { Subject } from 'rxjs';
import { NzMessageService } from 'ng-zorro-antd/message';
import { Component, OnInit, HostListener, AfterViewInit, ViewChild, OnDestroy } from "@angular/core";
import { MainService } from 'src/app/services/main.service';
import { ActivatedRoute, Router, NavigationEnd  } from '@angular/router';
import cloneDeep from 'lodash-es/cloneDeep'
import { CustomChangeDateComponent } from '../../components/custom-change-date/custom-change-date.component';
@Component({
  selector: "app-incident-list",
  templateUrl: "./incident-list.component.html",
  styleUrls: ["./incident-list.component.less"],
})
export class IncidentListComponent implements OnInit, AfterViewInit, OnDestroy {
  @ViewChild('customChangeDate', { static: false }) customChangeDateComponent!: CustomChangeDateComponent;
  constructor(
    private mainService: MainService,
    private message: NzMessageService,
    private route: ActivatedRoute,
		private router: Router,
    private tabService: TabService,
  ) {}

  listOfData: any[] = []; //表格数据
  listOfDataEnd: any[] = []; //表格合计
  pageIndex: number = 1; //表格当前页码
  pageSize: number = 10; //表格每页展示条数
  listLength: number = 0; //表格总数据量

  repairDeptId;//报修科室id

  searchTimerSubject = new Subject();
	dateData1:any;
	dateData2:any;
	
  ngOnInit() {
		// 数据下钻搜索
		this.getRouteQuery()
		// this.router.events
		//   .pipe(filter(event => event instanceof NavigationEnd))
		//   .subscribe((event: NavigationEnd) => {
		//     if(event.urlAfterRedirects=='/newStatistics/maintenanceStatistics/incidentList'){
		// 			console.log('维修=================')
		// 			this.getRouteQuery()
		//     }
		//   });

    this.searchTimerSubject.pipe(debounceTime(500)).subscribe((v) => {
      let fun = v[0];
      fun.call(this, v[1]);
    });
  }
	
	ngOnDestroy(){
		sessionStorage.removeItem('maintenanceData')
	}
	
  ngAfterViewInit(){
    this.initSessionData();
    this.onResize(0);
  }

  tableHeight:number = 0;
  @HostListener('window:resize')
  onResize(height): void {
    setTimeout(() => {
			this.tableHeight = window.innerHeight - (document.querySelector('.searchDataWrap') as HTMLElement).offsetHeight - 64 - 36 - 48 - 8 - (document.querySelector('.ant-table-header') as HTMLElement).offsetHeight - height - this.getMoreFilter + 14;
    }, 0)
  }
	
	goingType:boolean = false;
	getRouteQuery(){
		let data = sessionStorage.getItem('maintenanceData')
		let query = null
		if(data){
			query = JSON.parse(data)
			console.log('query==========',query)
			setTimeout(_=>{
				if(query.repairDeptId){
					this.getRepairDeptList();
					this.repairDeptId = query.repairDeptId
				}else{
					this.repairDeptId = undefined
				}
				if(query.searchQuery){
					this.goingType = true
					this.fieldConfig.fields = query.searchQuery
				}else{
					this.goingType = false
					this.fieldConfig.fields = {}
				}
				this.getQueryParams();
			},50)
		}else{
			setTimeout(_=>{
				this.getQueryParams();
			},50)
		}
	}
	
  getQueryParams(){
    let queryParams = this.tabService.getQueryParams();
    this.tabService.clearQueryParams();
		console.log(8989898,queryParams)
    if(queryParams.dateRange){
      this.dateRange = queryParams.dateRange;
      this.customChangeDateComponent.initByDate(this.dateRange, queryParams.defRange);
    }
		setTimeout(_=>{
			this.search();
			this.onResize(37);
		},50)
  }

  get getMoreFilter(){
    let flag = this.fieldConfig.fields.groupDTO || this.fieldConfig.fields.userDTO || 
		this.fieldConfig.fields.category1DTO || this.fieldConfig.fields.category2DTO || 
		this.fieldConfig.fields.category3DTO || this.fieldConfig.fields.sourceDTO  || 
		this.fieldConfig.fields.buildingDTO || this.fieldConfig.fields.floorDTO || 
		this.fieldConfig.fields.companyDTO || this.fieldConfig.fields.repairDeptDTO;
    return flag ? 37 : 0;
  }

  // 初始化缓存数据
  queryType:any;
  hosId:any;
  dutyId:any;
  parentDutyId:any;
  initSessionData(){
    let newStatistics = JSON.parse(sessionStorage.getItem('newStatistics'));
    let queryType:any = newStatistics.queryType;
    let hosId:any = newStatistics.hospitalId;
    let dutyId:any = newStatistics.dutyId;

    queryType = queryType ? +queryType : undefined;
    hosId = hosId ? +hosId : undefined;
    dutyId = dutyId ? +dutyId : undefined;

    this.queryType = queryType;
    if(queryType == 1){
      this.hosId = undefined;
      this.dutyId = undefined;
      this.parentDutyId = undefined;
    }else if(queryType == 2){
      this.hosId = hosId;
      this.dutyId = undefined;
      this.parentDutyId = undefined;
    }else if(queryType == 3){
      this.hosId = undefined;
      this.dutyId = dutyId;
      this.parentDutyId = undefined;
    }else if(queryType == 4){
      this.hosId = undefined;
      this.dutyId = undefined;
      this.parentDutyId = dutyId;
    }
  }

  get getHosId(){
    return this.parentDutyId || this.dutyId || this.hosId;
  }

  // 表格数据
  loading1 = false;
  getList(num?: number, field?: string, sort?: string) {
    if (num !== undefined) {
      this.pageIndex = num;
    }
    let postData:any = {
      idx: this.pageIndex - 1,
      sum: this.pageSize,
      dateType: this.customChangeDateComponent.dateType || undefined,
      startDate: this.customChangeDateComponent.startDate || undefined,
      endDate: this.customChangeDateComponent.endDate || undefined,
      hosId: this.hosId || undefined,
      dutyId: this.dutyId || undefined,
      parentDutyId: this.parentDutyId || undefined,
      repairDeptId: this.repairDeptId || undefined,
      groupId: this.fieldConfig.fields.userId ? undefined : (this.fieldConfig.fields.groupId || undefined),
      userId: this.fieldConfig.fields.userId || undefined,
      categoryId: this.fieldConfig.fields.categoryId || undefined,
      sourceId: this.fieldConfig.fields.sourceId || undefined,
      hierarchy: this.fieldConfig.fields.hierarchy || undefined,
			workHourId: undefined,
			buildingId: this.fieldConfig.fields.buildingId || undefined,
			placeId: this.fieldConfig.fields.floorId || undefined,
			companyId: this.fieldConfig.fields.companyId || undefined,
			repairUserId: this.fieldConfig.fields.repairUserId || undefined,
			consumableId: this.fieldConfig.fields.consumableId || undefined,
			timeout: this.fieldConfig.fields.overtimeId,
			hangUp: this.fieldConfig.fields.isHangId,
			incidentSign: this.fieldConfig.fields.codeNum,
			wxDegreeId: this.fieldConfig.fields.evaluateId,
			statusValue: this.fieldConfig.fields.statusValue || undefined,
			deptTypeId: this.fieldConfig.fields.deptTypeId || undefined,
    };
		
		if(this.fieldConfig.fields.workHourParentId && this.fieldConfig.fields.workHourSmallId){
			postData.workHourId = this.fieldConfig.fields.workHourSmallId
		}
		if(this.fieldConfig.fields.workHourParentId && !this.fieldConfig.fields.workHourSmallId){
			postData.workHourId = this.fieldConfig.fields.workHourParentId
		}
		
    this.loading1 = true;
    this.mainService
      .postCustom("itsm/report", "incidentWorkOrderList", postData)
      .subscribe((result) => {
        this.loading1 = false;
        this.listOfData = result.dataList;
        this.listLength = result.totalCount;
      });
  }

  // 列表排序
  sortCurrent:any = {};
  sortCurrentKey: string = "";
  sortCurrentValue: string | null = "";
  sort(e) {
    const { key, value } = e;
    this.sortCurrentKey = key;
    this.sortCurrentValue = value;
    this.getList(this.pageIndex, this.sortCurrentKey, this.sortCurrentValue);
  }

  // 搜索
  search() {
    this.getList(1, this.sortCurrentKey, this.sortCurrentValue);
  }

  // 日期选择
  dateRange: any = [];

  // 导出
  excelExportLoading:any = false;
  excelExport(){
    this.excelExportLoading = this.message.loading("导出中..", {
      nzDuration: 0,
    }).messageId;
    let postData:any = {
      idx: this.pageIndex - 1,
      sum: this.pageSize,
      dateType: this.customChangeDateComponent.dateType,
      startDate: this.customChangeDateComponent.startDate || undefined,
      endDate: this.customChangeDateComponent.endDate || undefined,
      hosId: this.hosId || undefined,
      dutyId: this.dutyId || undefined,
      parentDutyId: this.parentDutyId || undefined,
      repairDeptId: this.repairDeptId || undefined,
      groupId: this.fieldConfig.fields.userId ? undefined : (this.fieldConfig.fields.groupId || undefined),
      userId: this.fieldConfig.fields.userId || undefined,
      categoryId: this.fieldConfig.fields.categoryId || undefined,
      sourceId: this.fieldConfig.fields.sourceId || undefined,
      hierarchy: this.fieldConfig.fields.hierarchy || undefined,
    	workHourId: undefined,
    	buildingId: this.fieldConfig.fields.buildingId || undefined,
    	placeId: this.fieldConfig.fields.floorId || undefined,
    	companyId: this.fieldConfig.fields.companyId || undefined,
    	repairUserId: this.fieldConfig.fields.repairUserId || undefined,
    	consumableId: this.fieldConfig.fields.consumableId || undefined,
    	timeout: this.fieldConfig.fields.overtimeId,
    	hangUp: this.fieldConfig.fields.isHangId,
    	incidentSign: this.fieldConfig.fields.codeNum,
			wxDegreeId: this.fieldConfig.fields.evaluateId,
			statusValue: this.fieldConfig.fields.statusValue || undefined,
			deptTypeId: this.fieldConfig.fields.deptTypeId || undefined
    };
    
    if(this.fieldConfig.fields.workHourParentId && this.fieldConfig.fields.workHourSmallId){
    	postData.workHourId = this.fieldConfig.fields.workHourSmallId
    }
    if(this.fieldConfig.fields.workHourParentId && !this.fieldConfig.fields.workHourSmallId){
    	postData.workHourId = this.fieldConfig.fields.workHourParentId
    }
    this.mainService
      .postExportCustom("itsm/export", "incidentWorkOrderList", postData)
      .subscribe((data) => {
        this.message.remove(this.excelExportLoading);
        this.excelExportLoading = false;
        this.message.success('导出成功');
        var file = new Blob([data], {
          type: "application/vnd.ms-excel",
        });
        //trick to download store a file having its URL
        var fileURL = URL.createObjectURL(file);
        var a = document.createElement("a");
        a.href = fileURL;
        a.target = "_blank";
        a.download = `${this.route.parent.routeConfig.data.title}.xls`;
        document.body.appendChild(a);
        a.click();
      },(err) => {
        this.message.remove(this.excelExportLoading);
        this.excelExportLoading = false;
        this.message.error('导出失败');
      });
  }
  // 重置
  reset(){
    this.sortCurrentKey = "";
		this.sortCurrentValue = "";
		this.sortCurrent = {};
    this.dateRange = []
		this.dateData1 = null;
		this.dateData2 = null;
    this.repairDeptId = undefined;
    this.fieldConfig.fields = {groupId: undefined, userId: undefined, categoryId: undefined, sourceId: undefined, hierarchy: undefined};
    this.customChangeDateComponent.resetByDate();
		sessionStorage.removeItem('maintenanceData');
		setTimeout(_=>{
			this.search();
			this.onResize(0);
		})
  }

  // 科室搜索
  changeRepairDeptInp(e) {
    this.searchTimer(this.getRepairDeptList, e);
  }

  // 防抖
  isLoading = false;
  searchTimer(fun, e) {
    this.isLoading = true;
    this.searchTimerSubject.next([fun, e]);
  }
	
	// 查看工单详情
	coopData:any;
	detailModalShow = false; //弹窗开关
	viewDetail(data) {
	  this.coopData = data;
	  this.detailModalShow = true;
	}
	// 关闭弹窗
	closeDetailModelOrder(e) {
	  this.detailModalShow = JSON.parse(e).show;
	}
	// 弹窗确定
	confirmDetailModelOrder(e){
	  this.detailModalShow = false;
	  this.getList();
	}
	
  openChangeRepairDept(flag){
    flag && this.getRepairDeptList();
  }

  // 获取报修科室列表
  repairDeptList:any[] = [];
  getRepairDeptList(keyword?) {
    let data = {
      department: {
        statisticalHosId: this.getHosId,
        dept: keyword,
        searchType: 1,
      },
      idx: 0,
      sum: 20,
    };
    this.isLoading = true;
    this.mainService
      .getFetchDataList("data", "department", data)
      .subscribe((data) => {
        this.isLoading = false;
        this.repairDeptList = data.list;
      });
  }

  // 详细搜索
  fieldConfig:any = {
    fields: {groupId: undefined, userId: undefined, categoryId: undefined, sourceId: undefined, hierarchy: 
		undefined,buildingId: undefined, floorId: undefined, companyId: undefined, 
		workHourParentId: undefined, workHourSmallId: undefined, evaluateId: undefined, repairUserId: undefined, consumableId: undefined, isHangId: undefined, codeNum: undefined, overtimeId: undefined, deptTypeId: undefined},
    config: {groupAndUser: true, category123: true, source: true, buildingAndFloor: true, company: true, workHourParent: true, workHourSmall: true, evaluate: true, repairUser: true, consumable: true, isHang: true, code: true, overtime: true, deptType: true},
  }
  showSearchMore:boolean = false;
  showMore(){
    this.showSearchMore = true;
  }

  cancelEvent(){
    this.showSearchMore = false;
  }

  submitEvent(fields){
    this.showSearchMore = false;
    this.fieldConfig.fields = fields;
    console.log('this.fieldConfig.fields:', this.fieldConfig.fields)
    this.search();
    this.onResize(37);
  }
}
